// This code was "borrowed" from Vovin, creator of Red Planet
// Go to www.tribes2maps.com to check that map out

// PLEASE do not base any other missions off this code without giving credit
// to me for making this script and Vovin for originating the script.  Also,
// you must advertise the maps Mysterious Desert and Red Planet.  And please
// do NOT remove the Tribes2Maps.com site name.

// don't want this executing when building graphs
if($OFFLINE_NAV_BUILD)
   return;

echo("Running Mysterious Desert script!  Mysterious Desert script made by Red Shifter,");
echo("using code borrowed from Vovin, creator of Red Planet.  Check that map out too.");
echo("Go to www.tribes2maps.com for many cool and godlike maps!");

//Script for Mysterious Desert
//===================================================================================


// package and callbacks
activatePackage(MysteriousDesert);

// Mission Variables

game.BlueGenFF = nameToId(BlueGenFF);
game.RedGenFF = nameToId(RedGenFF);
game.GreenGenFF = nameToId(GreenGenFF);
game.YellowGenFF = nameToId(YellowGenFF);

game.BlueGen = nameToId(BlueGen);
game.RedGen = nameToId(RedGen);
game.GreenGen = nameToId(GreenGen);
game.YellowGen = nameToId(YellowGen);

game.AntiBlueGen = nameToId(AntiBlueGen);
game.AntiRedGen = nameToId(AntiRedGen);
game.AntiGreenGen = nameToId(AntiGreenGen);
game.AntiYellowGen = nameToId(AntiYellowGen);

// If you change the code, CHANGE THE PACKAGE NAME!
package MysteriousDesert {

function FirstStrikeOfMysteriousDesert()
{
        // Make sure that coding doesn't accidentally run
        $ObjectivesComplete = 0;
        $DontRunCode = 1;
        $BlueGenBlowdUp = 0;
        $RedGenBlowdUp = 0;
        $YellowGenBlowdUp = 0;
        $GreenGenBlowdUp = 0;

        game.BlueGenFF.SetDamageState(Enabled);
        game.RedGenFF.SetDamageState(Enabled);
        game.GreenGenFF.SetDamageState(Enabled);
        game.YellowGenFF.SetDamageState(Enabled);

        game.AntiBlueGen.SetDamageState(Disabled);
        game.AntiRedGen.SetDamageState(Disabled);
        game.AntiGreenGen.SetDamageState(Disabled);
        game.AntiYellowGen.SetDamageState(Disabled);

        game.BlueGen.SetDamageState(Disabled);
        game.RedGen.SetDamageState(Disabled);
        game.GreenGen.SetDamageState(Disabled);
        game.YellowGen.SetDamageState(Disabled);

        game.BlueGen.setDamageLevel(0);
        game.RedGen.setDamageLevel(0);
        game.GreenGen.setDamageLevel(0);
        game.YellowGen.setDamageLevel(0);

        messageall(0, "\c5Proximity alert!  60 seconds to security system activation.");
        schedule(60000, 0, EnterTheMysteriousDesert);
}

function EnterTheMysteriousDesert()
{
        game.BlueGenFF.SetDamageState(Disabled);
        game.RedGenFF.SetDamageState(Disabled);
        game.GreenGenFF.SetDamageState(Disabled);
        game.YellowGenFF.SetDamageState(Disabled);

        game.AntiBlueGen.SetDamageState(Enabled);
        game.AntiRedGen.SetDamageState(Enabled);
        game.AntiGreenGen.SetDamageState(Enabled);
        game.AntiYellowGen.SetDamageState(Enabled);

        game.BlueGen.SetDamageState(Enabled);
        game.RedGen.SetDamageState(Enabled);
        game.GreenGen.SetDamageState(Enabled);
        game.YellowGen.SetDamageState(Enabled);

        messageall(0, "\c5Security system activated.  Colored generators operational.");
        $DontRunCode = 0;
}

function Generator::onDestroyed(%data, %destroyedObj)
{
        //error("GeneratorLarge::onDestroyed");

        Parent::onDestroyed(%data, %destroyedObj);

        // Stops accidental running of objectives at mission start
        if ($DontRunCode == 1)
                return;
     
        if (%destroyedObj == game.BlueGen){
                game.BlueGenFF.SetDamageState(Enabled);
                game.AntiBlueGen.SetDamageState(Disabled);
                $BlueGenBlowdUp = 1;
	}

        if (%destroyedObj == game.RedGen){
                game.RedGenFF.SetDamageState(Enabled);
                game.AntiRedGen.SetDamageState(Disabled);
                $RedGenBlowdUp = 1;
	}

        if (%destroyedObj == game.GreenGen){
                game.GreenGenFF.SetDamageState(Enabled);
                game.AntiGreenGen.SetDamageState(Disabled);
                $GreenGenBlowdUp = 1;
	}

        if (%destroyedObj == game.YellowGen){
                game.YellowGenFF.SetDamageState(Enabled);
                game.AntiYellowGen.SetDamageState(Disabled);
                $YellowGenBlowdUp = 1;
	}

        //If the four objectives have been destroyed the counters =1
        //Let the people know that the entrance gens are down.
        if (($ObjectivesComplete == 0) && ($BlueGenBlowdUp == 1) && ($RedGenBlowdUp == 1) && ($GreenGenBlowdUp == 1) && ($YellowGenBlowdUp == 1)) {
                $ObjectivesComplete = 1;
                messageall(0, "\c5Security system malfunction.  Security system is offline.  Immediate threat detected.");
	}
}

// Next functions begin with SiegeGame because Siege is the gametype.  To
// adapt for CTF, you would change it to CTFGame::startMatch(%game)
function SiegeGame::startMatch(%game)
{
        // Runs function FirstStrikeOfMysteriousDesert on game start
        Parent::startMatch(%game);
        FirstStrikeOfMysteriousDesert();
}

function SiegeGame::startSecondHalf(%game)
{
        // Runs function FirstStrikeOfMysteriousDesert on second half.
        // This is only required in Siege.
        Parent::startSecondHalf(%game);
        FirstStrikeOfMysteriousDesert();
}

function SiegeGame::gameOver(%game)
{
        Parent::gameOver(%game);
        // Clean up the coding, remove everything having to do with the
        // Mysterious Desert, all by deactivating the package.
        deactivatePackage(MysteriousDesert);
}

function Generator::onEnabled(%data, %obj, %prevState)
{
   // Prevent repairs on colored generators (you can repair through FFs)
   // The damn FF bug causes a few thousand glitches, as the ENTIRE coding
   // must be designed around this bug.

   Parent::onEnabled(%data, %obj, %prevState);

   if ((%obj == game.BlueGen) && ($BlueGenBlowdUp == 1)) {
        game.BlueGen.setDamageLevel(2.5);
   }
   if ((%obj == game.RedGen) && ($RedGenBlowdUp == 1)) {
        game.RedGen.setDamageLevel(2.5);
   }
   if ((%obj == game.GreenGen) && ($GreenGenBlowdUp == 1)) {
        game.GreenGen.setDamageLevel(2.5);
   }
   if ((%obj == game.YellowGen) && ($YellowGenBlowdUp == 1)) {
        game.YellowGen.setDamageLevel(2.5);
   }
}

function FlipFlop::playerTouch(%data, %flipflop, %player)
{
        $BlueGenBlowdUp = 0;
        $RedGenBlowdUp = 0;
        $YellowGenBlowdUp = 0;
        $GreenGenBlowdUp = 0;
        $DontRunCode = 1;

        Parent::playerTouch(%data, %flipflop, %player);
}

function ShowMeDaMoney()
{
        // Not so much a function as a debugging method
        show("$BlueGenBlowdUp @ $RedGenBlowdUp @ $YellowGenBlowdUp @ $GreenGenBlowdUp");
}

};
